class Test
{
	private static String dir2String(int dir) {
		switch (dir) {
		case 0:
			return "Nord";
		case 1:
			return "Est";
		case 2:
			return "Sud";
		case 3:
			return "Ovest";
		default:
			return "Unknown";
		}
	}
	private static int String2dir(String s) {
		String s1 = s.toUpperCase();
		if (s1.equals("NORD"))
			return 0;
		if (s1.equals("EST"))
			return 1;
		if (s1.equals("SUD"))
			return 2;
		if (s1.equals("OVEST"))
			return 3;
		return -1;
	}
	private static void elenca(String msg, Oggetto[] o)
	{
		Console.scriviStringa(msg);
		if (o.length == 0)
		{
			Console.scriviStringa("Niente.");
			return;
		}
		for (int i = 0; i < o.length; i++)
			Console.scriviStringa(o[i].nome());
	}
	private static Oggetto cerca(Oggetto[] o, String nome)
	{
		for (int i = 0; i < o.length; i++)
		{
			if (nome.equals(o[i].nome()))
				return o[i];
		}
		return null;
	}
	public static void main(String[] args)
	{
		Stanza s1 = new Stanza("stanza 1");
		Stanza s2 = new Stanza("stanza 2");
		Stanza s3 = new Stanza("stanza 3");
		Porta p1 = new Porta(s1, s2);
		s1.collega(1, p1);
		s2.collega(3, p1);
		Porta p2 = new Porta(s2, s3);
		s2.collega(2, p2);
		s3.collega(0, p2);
		Oggetto c1 = new MobileImpl("oggetto1", s1);
		Oggetto c2 = new MobileImpl("oggetto2", s2);
		Giocatore giocatore = new Giocatore("Giocatore", s1);
		boolean ancora = true;
		while (ancora)
		{
			Stanza stanza = (Stanza) giocatore.luogo();
			Console.scriviStringa("***************************");
			Console.scriviStringa(stanza.descrivi());
			int[] dir = stanza.direzioni();
			if (dir.length > 0)
			{
				Console.scriviStr("Puoi andare a: ");
				for (int i = 0; i < dir.length; i++)
					Console.scriviStr(dir2String(dir[i]) + " ");
				Console.nuovaLinea();
			}
			Oggetto[] oggetti = stanza.elenco();
			elenca("Vedi:", oggetti);
			Console.scriviStringa("Cosa vuoi fare?");
			String in = Console.leggiStringa();
			Risultato r = null;
			if (in.equals("fine"))
				ancora = false;
			else if (in.equals("vai"))
			{
				in = Console.leggiStringa();
				if (
						in.equals("nord") || in.equals("sud") ||
						in.equals("est") || in.equals("ovest"))
				{
					int d = String2dir(in.toUpperCase());
					r = stanza.vai(giocatore, d);
				}
				else
					r = new Risultato(
							false, "Non conosco la direzione " + in);
			}
			else if (in.equals("prendi"))
			{
				in = Console.leggiStringa();
				Oggetto o = cerca(oggetti, in);
				if (o == null)
					r = new Risultato(
							false, "Non vedo " + in + " qui.");
				else if (o == giocatore)
					r = new Risultato(
							false,
							"Sei, per caso, il Barone di Munchausen?");
				else if (!(o instanceof Mobile))
					r = new Risultato(false, "Non si muove.");
				else
					r = ((Mobile) o).sposta(stanza, giocatore);
			}
			else if (in.equals("lascia"))
			{
				in = Console.leggiStringa();
				Oggetto o = (Oggetto) cerca(giocatore.elenco(), in);
				if (o == null)
					r = new Risultato(false, "Non possiedi " + in);
				else
					r = ((Mobile) o).sposta(giocatore, stanza);
			}
			else if (in.equals("inventario"))
				elenca("Possiedi: ", giocatore.elenco());
			else
				r = new Risultato(false, "Non capisco.");
			if (r != null)
				Console.scriviStringa(r.getMessage());
		}
	}
}
